module_name = 'ccpro_dynamic_form_list';

// DOCUMENT READY
$(document).ready(function() {
    hide_route_inputs();
    hide_list_inputs();

    if($('#type_update').val() == 'Route'){
	show_route_inputs();
	getAvailableNodes();
	getRoutes($('#id_field').val());
    }

    if($('#type_update').val() == 'List'){
	show_list_inputs();
	getListOptions($('#id_field').val());
    }
});

// Update field. Event: Click
$('#update_field').click(function(){
    /** ¿Falta funcionalidad? */    
    add_mode = $('#add_mode').val();
    id_field = $('#id_field').val();
    id_node  = $('#id_node').val();
    field_description = $('#field_description').val();
    field_type        = $('#field_type').val();    

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       	module_name, 
	    rawmode:    	'yes',
	    action:     	'updateField',
	    add_mode:		add_mode,
	    id_field:		id_field,
	    id_node:		id_node,
	    field_description:  field_description,
	    field_type:  	field_type
	},function (result) {
	    if(result.status == 0){
		$('#selected_options').html("");
		$("#status_node").css({ 'color': 'green', 'font-size': '100%'});
	    }

	    if(result.status == 1){
		$("#status_node").css({ 'color': 'red', 'font-size': '100%'});
	    }
	    $('#status_node').html(result.message);

	    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
		    menu:       module_name, 
		    rawmode:    'yes',
		    action:     'updateFieldList'
	    },function (result2) { // esto viene como html
		    $("#field_list").html(result2);
		}
	    ); // fin del post secundario
	}
    ); // fin del post primario
});

// ADD FIELD CLICK
$('#add_field').click(function(){    
    field_description = $('#field_description').val();
    field_type        = $('#field_type').val();    

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       	module_name, 
	    rawmode:    	'yes',
	    action:     	'addField',
	    field_description:  field_description,
	    field_type:  	field_type
	},function (result) {
	    if(result.status == 0){
		$('#selected_options').html("");
		$("#status_node").css({ 'color': 'green', 'font-size': '100%'});
	    }

	    if(result.status == 1){
		$("#status_node").css({ 'color': 'red', 'font-size': '100%'});
	    }
	    $('#status_node').html(result.message);

	    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
		    menu:       module_name, 
		    rawmode:    'yes',
		    action:     'updateFieldList'
	    },function (result2) { // esto viene como html
		    $("#field_list").html(result2);
		}
	    ); // fin del post secundario
	}
    ); // fin del post primario
});

// FIELD TYPE CHANGE
$('#field_type').change(function(){    
    if($('#field_type').val() == 'List'){
	show_list_inputs();
	$('#selected_options').html('');
	deleteOptions('','ALL')
    }else{
	hide_list_inputs();
    }

    if($('#field_type').val() == 'Route'){
	show_route_inputs();
	deleteRoutes('','ALL');
	// getAvailableNodes();
    }else{
	hide_route_inputs();
    }
});

/* Add Option Event: Click */ 
$('#add_option').click(function(){
    id_field = $('#id_field').val();    
    option   = $('#option_val').val();
    add_mode = $('#add_mode').val();

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'addOption',
	    option:	option,
	    id_field:	id_field,
	    add_mode:	add_mode
    },function (result) {
	if(result.status == 1){
	    $("#status_node").css({ 'color': 'red', 'font-size': '100%' });
	}
	if(result.status == 0){
	    $("#status_node").css({ 'color': 'green', 'font-size': '100%' });
	}

	$('#status_node').html(result.message);
	getListOptions(id_field);
    });
});


/* Add Route Event: Click */
$('#add_route').click(function(){
    id_field = $('#id_field').val();
    id_dest  = $( "#available_nodes option:selected" ).val();
    id_node  = $('#id_node').val();
    route    = $('#route_val').val();
    add_mode = $('#add_mode').val();

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'addRoute',
	    id_node:	id_node,
	    id_dest:	id_dest,
	    id_field:	id_field,
	    route:	route,
	    add_mode: 	add_mode
    },function (result) {
	if(result.status == 1){
	    $("#status_node").css({ 'color': 'red', 'font-size': '100%' });
	}
	if(result.status == 0){
	    $("#status_node").css({ 'color': 'green', 'font-size': '100%' });
	}

	$('#status_node').html(result.message);
	getRoutes(id_field);
    });
});


// Delete Option Event: click
$('#del_option').click(function(){
    id_field = $('#id_field').val();
    // options es un string con la forma 1, 2, 4; donde 1, 2, y son los indices dentro del option
    options = $("#selected_options :selected").map(function(){ return this.value }).get().join(",");
    deleteOptions(id_field, options);

});


// Delete Route Event: click
$('#del_route').click(function(){
    id_field = $('#id_field').val();    
    routes = $("#selected_routes :selected").map(function(){ return this.value }).get().join(",");
    deleteRoutes(id_field, routes);    
});


function deleteOptions(id_field, options)
{
    add_mode = $('#add_mode').val();
    id_node  = $('#id_node').val();

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'deleteOptions',
	    options:	options,
	    id_field:   id_field,
	    id_node:	id_node,
	    add_mode: 	add_mode
    },function (result) {
	getListOptions(id_field);
    });
}

function deleteRoutes(id_field, routes)
{
    add_mode = $('#add_mode').val();
    id_node  = $('#id_node').val();

    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'deleteRoutes',
	    routes:	routes,
	    id_field:   id_field,
	    id_node:	id_node,
	    add_mode:	add_mode
    },function (result) {
	getRoutes(id_field);
	getAvailableNodes();
    });
}

// Esta función llena el select de nodos disponibles (para Rutas)
function getAvailableNodes()
{
    $('#available_nodes').html('');
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'getAvailableNodes'
    },function (result) {	
	$.each(result, function(i, data){
	    $('#available_nodes').append('<option value=' + data.id_node +'>' + data.name + '</option>');
	}) 
    });
}

// Esta función llena el select de opciones (para Listas)
function getListOptions(id_field)
{
    console.log('getListOptions');
    add_mode = $('#add_mode').val();
    $('#selected_options').html('');
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'getListOptions',
	    id_field:	id_field,
	    add_mode: 	add_mode
    },function (result) {
	$.each(result, function(i, data){
	    $('#selected_options').append('<option value=' + i +'>' + data + '</option>');
	}) 
    });
}

function getRoutes(id_field)
{
    add_mode = $('#add_mode').val();
    id_node  = $('#id_node').val();
    
    $('#selected_routes').html('');
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
	    menu:       module_name, 
	    rawmode:    'yes',
	    action:     'getRoutes',
	    id_field:	id_field,
	    id_node:	id_node,
	    add_mode: 	add_mode
    },function (result) {
	$.each(result, function(i, data){
	    $('#selected_routes').append('<option value=' + i +'>' + data + '</option>');
	}) 
    });
}

function hide_route_inputs()
{
    $('#route_elements').hide();
}

function show_route_inputs()
{
    $('#route_elements').show();
}

function hide_list_inputs()
{
    $('#list_elements').hide();
}

function show_list_inputs()
{
    $('#list_elements').show();
}
